function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import * as echarts from 'echarts';
import { useEffect, useState } from 'react';
import ReactEcharts from 'echarts-for-react';
import { jsx as _jsx } from "react/jsx-runtime";
var BarList = function BarList(props) {
  var _useState = useState({}),
    _useState2 = _slicedToArray(_useState, 2),
    option = _useState2[0],
    setOption = _useState2[1];
  var height = props.height,
    yLabel = props.yLabel;
  var showLabel = yLabel == 'value' ? '{value}' : '{value} %';
  useEffect(function () {
    var datas = (props === null || props === void 0 ? void 0 : props.data) || [];
    var optionNew = {
      backgroundColor: 'transparent',
      grid: {
        left: '10',
        right: 0,
        bottom: '3%',
        top: '10%',
        containLabel: true
      },
      tooltip: {
        trigger: 'axis',
        axisPointer: {
          type: 'shadow'
        },
        valueFormatter: function valueFormatter(value) {
          return '$' + value.toFixed(2);
        }
      },
      xAxis: {
        type: 'category',
        data: datas === null || datas === void 0 ? void 0 : datas.map(function (item) {
          return item === null || item === void 0 ? void 0 : item.name;
        }),
        //数据
        axisLabel: {
          color: 'white',
          formatter: function formatter(value) {
            var a = value.slice(0, 2);
            var b = value.slice(2);
            var c = "".concat(a, "\n").concat(b);
            return c;
          },
          fontSize: 18
        },
        axisLine: {
          show: true
        },
        axisTick: false
      },
      yAxis: {
        type: 'value',
        axisLine: {
          //坐标轴样式
          show: false //不显示
        },

        axisLabel: {
          color: 'white',
          formatter: showLabel,
          fontSize: 18
        },
        splitLine: {
          //分隔辅助线
          lineStyle: {
            type: 'dashed',
            //线的类型 虚线0
            opacity: 1 //透明度
          }
        }
      },

      series: [{
        type: 'pictorialBar',
        symbol: 'rect',
        symbolSize: [40, 3],
        symbolOffset: [0, 0],
        itemStyle: {
          color: '#00BCFF'
        },
        tooltip: {
          show: false
        },
        data: datas === null || datas === void 0 ? void 0 : datas.map(function (item) {
          return item === null || item === void 0 ? void 0 : item.value;
        })
      }, {
        type: 'bar',
        barWidth: 40,
        data: datas === null || datas === void 0 ? void 0 : datas.map(function (item) {
          return item === null || item === void 0 ? void 0 : item.value;
        }),
        itemStyle: {
          color: function color(params, api) {
            if ((params === null || params === void 0 ? void 0 : params.data) < 0) {
              return new echarts.graphic.LinearGradient(0, 0, 0, 1, [{
                offset: 1,
                color: '#00BCFF'
              }, {
                offset: 0,
                color: 'rgba(51, 173, 234, 0)'
              }]);
            } else {
              return new echarts.graphic.LinearGradient(0, 0, 0, 1, [{
                offset: 0,
                color: '#00BCFF'
              }, {
                offset: 1,
                color: 'rgba(51, 173, 234, 0)'
              }]);
            }
          }
        },
        label: {
          show: true,
          position: 'top',
          // 位置
          color: '#fff',
          fontSize: 15,
          distance: 10 // 距离
          // formatter: '{c}%' // 这里是数据展示的时候显示的数据
        }
      }]
    };

    setOption(optionNew);
  }, [props === null || props === void 0 ? void 0 : props.name]);
  return /*#__PURE__*/_jsx(ReactEcharts, _objectSpread({
    option: option,
    theme: "Imooc"
  }, props));
};
export default BarList;